; The following equates show data references outside the range of the program.

data_12e	equ	676h

seg_a		segment	byte public
		assume	cs:seg_a, ds:seg_a


		org	0

password	proc	far

header		dd	0FFFFFFFFh
attributes	dw	8000h
pointers	dw	offset strategy
		dw	offset commands
char_dev	db	'@SYS$PWD'
data_1		db	0AFh
		db	0BFh,0AEh,0AFh,0ACh,0B5h,0ABh
		db	0BCh, 00h,0A2h, 00h
		db	24h
		db	8 dup (24h)
data_3		dd	00000h

password	endp

;
;
;                       External Entry Point
;
;

strategy	proc	far
		mov	word ptr cs:data_3,bx
		mov	word ptr cs:data_3+2,es
		retf				; Return far
strategy	endp


;
;
;                       External Entry Point
;
;

commands	proc	far
		push	ax
		push	bx
		push	cx
		push	dx
		push	ds
		push	es
		push	si
		push	di
		les	bx,cs:data_3		; Load 32 bit ptr
		mov	al,es:[bx+2]
		or	al,al			; Zero ?
		jnz	loc_1			; Jump if not zero
		mov	word ptr es:[bx+3],100h
		mov	word ptr es:[bx+0Eh],0
		mov	es:[bx+10h],cs
		call	sub_2
loc_1:
		pop	di
		pop	si
		pop	es
		pop	ds
		pop	dx
		pop	cx
		pop	bx
		pop	ax
		retf				; Return far
commands	endp


;
;                              SUBROUTINE
;

sub_1		proc	near
		push	cx
		mov	ah,0Fh
		int	10h			; Video display   ah=functn 0Fh
						;  get state, al=mode, bh=page
						;   ah=columns on screen
		cmp	al,7
		je	loc_2			; Jump if equal
		mov	ax,0B800h
		jmp	short loc_3
		db	90h
loc_2:
		mov	ax,0B000h
loc_3:
		mov	es,ax
		mov	si,offset data_5
		mov	di,data_12e
		mov	cx,5

locloop_4:
		push	cx
		mov	cx,34h

locloop_5:
		mov	al,[si]
		mov	ah,es:[di]
		mov	[si],ah
		mov	es:[di],al
		inc	si
		inc	di
		loop	locloop_5		; Loop if cx > 0

		pop	cx
		add	di,6Ch
		loop	locloop_4		; Loop if cx > 0

		pop	cx
		retn
sub_1		endp


;
;                              SUBROUTINE
;

sub_2		proc	near
		mov	ax,cs
		mov	ds,ax
		mov	ah,1
		mov	cx,2000h
		int	10h			; Video display   ah=functn 01h
						;  set cursor mode in cx
		call	sub_1
loc_6:
		mov	bx,1FFh
		xor	cl,cl			; Zero register
loc_7:
		xor	ax,ax			; Zero register
		int	16h			; Keyboard i/o  ah=function 00h
						;  get keybd char in al, ah=scan
		cmp	al,61h			; 'a'
		jb	loc_8			; Jump if below
		cmp	al,7Ah			; 'z'
		ja	loc_8			; Jump if above
		sub	al,20h			; ' '
loc_8:
		cmp	al,0Dh
		je	loc_10			; Jump if equal
		cmp	bx,offset data_11
		jb	loc_9			; Jump if below
		jmp	short loc_7
loc_9:
		xor	al,0FFh
		xor	al,cl
		mov	cs:[bx],al
		inc	bx
		inc	cl
		jmp	short loc_7
loc_10:
		xor	al,al			; Zero register
		mov	cs:[bx],al
		mov	si,offset data_1
		mov	bx,offset data_9
loc_11:
		lodsb				; String [si] to al
		cmp	al,cs:[bx]
		pushf				; Push flags
		inc	bx
		popf				; Pop flags
		jz	loc_12			; Jump if zero
		jmp	short loc_6
loc_12:
		cmp	al,0
		jne	loc_11			; Jump if not equal
		call	sub_1
		mov	ah,1
		mov	cx,0B0Ch
		int	10h			; Video display   ah=functn 01h
						;  set cursor mode in cx
		retn
sub_2		endp

data_5		db	0C9h
		db	 4Eh,0CDh, 4Eh,0CDh, 4Eh,0CDh
		db	 4Eh,0CDh, 4Eh,0CDh, 4Eh,0CDh
		db	 4Eh,0CDh, 4Eh,0CDh, 4Eh,0CDh
		db	 4Eh,0CDh, 4Eh,0CDh, 4Eh,0CDh
		db	 4Eh,0CDh, 4Eh,0CDh, 4Eh,0CDh
		db	 4Eh,0CDh, 4Eh,0CDh, 4Eh,0CDh
		db	 4Eh,0CDh, 4Eh,0CDh, 4Eh,0CDh
		db	 4Eh,0CDh, 4Eh,0CDh, 4Eh,0CDh
		db	 4Eh,0BBh, 4Eh,0BAh
		db	'N N N N N N N N N N N N N N N N '
		db	'N N N N N N N N N'
		db	0BAh, 4Eh,0BAh
		db	'N N NEOnOtOeOrO OyOoOuOrO OpOaOs'
		db	'OsOwOoOrOdO:O N N'
		db	0BAh, 4Eh,0BAh
		db	'N N N N N N N N N N N N N N N N '
		db	'N N N N N N N N N'
		db	0BAh, 4Eh,0C8h, 4Eh,0CDh, 4Eh
		db	0CDh, 4Eh,0CDh, 4Eh,0CDh, 4Eh
		db	0CDh, 4Eh,0CDh, 4Eh,0CDh, 4Eh
		db	0CDh, 4Eh,0CDh, 4Eh,0CDh, 4Eh
		db	0CDh, 4Eh,0CDh, 4Eh,0CDh, 4Eh
		db	0CDh, 4Eh,0CDh, 4Eh,0CDh, 4Eh
		db	0CDh, 4Eh,0CDh, 4Eh,0CDh, 4Eh
		db	0CDh, 4Eh,0CDh, 4Eh,0CDh, 4Eh
		db	0CDh, 4Eh,0CDh, 4Eh,0BCh
		db	4Eh
data_9		db	23h
		db	18 dup (23h)
data_11		db	23h

seg_a		ends



		end
